package cn.com.ctop.common.module.utils;

import cn.com.ctop.common.module.entity.TagInfo;
import cn.com.ctop.common.module.model.TagIdModel;
import cn.com.ctop.common.module.model.TagInfoTreeModel;
import org.jeecg.common.util.oConvertUtils;

import java.util.ArrayList;
import java.util.List;

public class FindstagInfosChildrenUtil {
    //部门树信息-树结构
    //private static List<SysDepartTreeModel> sysDepartTreeList = new ArrayList<SysDepartTreeModel>();

    //部门树id-树结构
    //private static List<DepartIdModel> idList = new ArrayList<>();


    /**
     * queryTreeList的子方法 ====1=====
     * 该方法是s将SysDepart类型的list集合转换成SysDepartTreeModel类型的集合
     */
    public static List<TagInfoTreeModel> wrapTreeDataToTreeList(List<TagInfo> recordList) {
        // 在该方法每请求一次,都要对全局list集合进行一次清理
        //idList.clear();
        List<TagIdModel> idList = new ArrayList<>();
        List<TagInfoTreeModel> records = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            TagInfo depart = recordList.get(i);
            records.add(new TagInfoTreeModel(depart));
        }
        List<TagInfoTreeModel> tree = findChildren(records, idList);
        setEmptyChildrenAsNull(tree);
        return tree;
    }

    /**
     * 获取 DepartIdModel
     * @param recordList
     * @return
     */
    public static List<TagIdModel> wrapTreeDataToDepartIdTreeList(List<TagInfo> recordList) {
        // 在该方法每请求一次,都要对全局list集合进行一次清理
        //idList.clear();
        List<TagIdModel> idList = new ArrayList<TagIdModel>();
        List<TagInfoTreeModel> records = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            TagInfo depart = recordList.get(i);
            records.add(new TagInfoTreeModel(depart));
        }
        findChildren(records, idList);
        return idList;
    }

    /**
     * queryTreeList的子方法 ====2=====
     * 该方法是找到并封装顶级父类的节点到TreeList集合
     */
    private static List<TagInfoTreeModel> findChildren(List<TagInfoTreeModel> recordList,
                                                         List<TagIdModel> departIdList) {

        List<TagInfoTreeModel> treeList = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            TagInfoTreeModel branch = recordList.get(i);
            if (oConvertUtils.isEmpty(branch.getParentId())) {
                treeList.add(branch);
                TagIdModel departIdModel = new TagIdModel().convert(branch);
                departIdList.add(departIdModel);
            }
        }
        getGrandChildren(treeList,recordList,departIdList);

        //idList = departIdList;
        return treeList;
    }

    /**
     * queryTreeList的子方法====3====
     *该方法是找到顶级父类下的所有子节点集合并封装到TreeList集合
     */
    private static void getGrandChildren(List<TagInfoTreeModel> treeList,List<TagInfoTreeModel> recordList,List<TagIdModel> idList) {

        for (int i = 0; i < treeList.size(); i++) {
            TagInfoTreeModel model = treeList.get(i);
            TagIdModel idModel = idList.get(i);
            for (int i1 = 0; i1 < recordList.size(); i1++) {
                TagInfoTreeModel m = recordList.get(i1);
                if (m.getParentId()!=null && m.getParentId().equals(model.getId())) {
                    model.getChildren().add(m);
                    TagIdModel dim = new TagIdModel().convert(m);
                    idModel.getChildren().add(dim);
                }
            }
            getGrandChildren(treeList.get(i).getChildren(), recordList, idList.get(i).getChildren());
        }

    }


    /**
     * queryTreeList的子方法 ====4====
     * 该方法是将子节点为空的List集合设置为Null值
     */
    private static void setEmptyChildrenAsNull(List<TagInfoTreeModel> treeList) {

        for (int i = 0; i < treeList.size(); i++) {
            TagInfoTreeModel model = treeList.get(i);
            if (model.getChildren().size() == 0) {
                model.setChildren(null);
                model.setIsLeaf(true);
            }else{
                setEmptyChildrenAsNull(model.getChildren());
                model.setIsLeaf(false);
            }
        }
        // sysDepartTreeList = treeList;
    }
}
